codeforces Star sky(二维前缀和)

传送门

C. Star sky
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

The Cartesian coordinate system is set in the sky. There you can see n stars, the i-th has coordinates (xiyi), a maximum brightness c, equal for all stars, and an initial brightness si (0 ≤ si ≤ c).

Over time the stars twinkle. At moment 0 the i-th star has brightness si. Let at moment t some star has brightness x. Then at moment (t + 1) this star will have brightness x + 1, if x + 1 ≤ c, and 0, otherwise.

You want to look at the sky q times. In the i-th time you will look at the moment ti and you will see a rectangle with sides parallel to the coordinate axes, the lower left corner has coordinates (x1iy1i) and the upper right — (x2iy2i). For each view, you want to know the total brightness of the stars lying in the viewed rectangle.

A star lies in a rectangle if it lies on its border or lies strictly inside it.

Input

The first line contains three integers nqc (1 ≤ n, q ≤ 1051 ≤ c ≤ 10) — the number of the stars, the number of the views and the maximum brightness of the stars.

The next n lines contain the stars description. The i-th from these lines contains three integers xiyisi (1 ≤ xi, yi ≤ 1000 ≤ si ≤ c ≤ 10) — the coordinates of i-th star and its initial brightness.

The next q lines contain the views description. The i-th from these lines contains five integers tix1iy1ix2iy2i (0 ≤ ti ≤ 1091 ≤ x1i < x2i ≤ 1001 ≤ y1i < y2i ≤ 100) — the moment of the i-th view and the coordinates of the viewed rectangle.

Output

For each view print the total brightness of the viewed stars.

Examples
input
2 3 3
1 1 1
3 2 0
2 1 1 2 2
0 2 1 4 5
5 1 1 5 5
output
3
0
3
input
3 4 5
1 1 2
2 3 0
3 3 1
0 1 1 100 100
1 2 2 4 4
2 2 1 4 7
1 50 50 51 51
output
3
3
5
0
Note

Let's consider the first example.

At the first view, you can see only the first star. At moment 2 its brightness is 3, so the answer is 3.

At the second view, you can see only the second star. At moment 0 its brightness is 0, so the answer is 0.

At the third view, you can see both stars. At moment 5 brightness of the first is 2, and brightness of the second is 1, so the answer is 3.


题意:给定n个点,点的坐标为(x,y),每个点上有一个亮度为s的星星,星星的亮度随时间的增加一秒而增加1,但是当星星的亮度达到c+1时置为0,然后有随时间的增加而增加。然后输入q次查询,每次查询的输入为:时间t,左下角的坐标(x1,y1),右上角的坐标(x2,y2),求问t时刻,在这个矩形内,所有星星的总亮度为多少?

题解:显然是一个二维前缀和,刚开始看错题意wa了一发。。。用一个三维的dp数组,dp[i][j][k]表示(0,0)到(i,j)的矩形内亮度为k的星星的个数,c小于等于10,所以无论何时星星的亮度不会超过10。t时刻,初始亮度为k的星星的亮度为(k+t)%(c+1)。这里注意二维前缀和的写法,最好画个图表示,不然很容易忽略掉某个区域。


#include<stdio.h>
#include<iostream>
#include<string>
#include<string.h>
#include<algorithm>
#include<set>
#include<stdlib.h>
#include<queue>
#include<vector>
#include<math.h>
using namespace std;
typedef long long ll;
int n , q , c;
int dp[105][105][15];
int main()
{
    int t , x1 , y1 , x2 , y2;
    while(~scanf("%d%d%d" , &n , &q , &c)){
        memset(dp , 0 , sizeof(dp));
        for(int i = 0 ; i < n ; i ++){
            int x , y , s ;
            scanf("%d %d %d" , &x , &y , &s);
            dp[x][y][s]++;
        }
        for(int i = 1 ; i <= 100 ; i ++){
            for(int j = 1 ; j <= 100 ; j ++){
                for(int k = 0 ; k < 15 ; k ++){
                    dp[i][j][k] += dp[i-1][j][k] + dp[i][j-1][k] - dp[i-1][j-1][k];
                }
            }
        }
        while(q--){
            scanf("%d%d%d%d%d" , &t , &x1 , &y1 , &x2 , &y2);
            int ans = 0 ;
            for(int k = 0 ; k < 15 ; k ++){
                int pre = dp[x2][y2][k] - dp[x2][y1-1][k] - dp[x1-1][y2][k] + dp[x1-1][y1-1][k];
                ans += pre*((k+t)%(c+1));
            }
            cout<<ans<<endl;
        }
    }
    return 0;
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值